commit 998db86a5c6ec50cea533042e40bcd92d7375560
Author: freddy77 <freddy77>
Date:   Tue Jan 26 11:21:10 2010 +0000

    add experimental support for SSPI (not enabled by default)

diff --git a/ChangeLog b/ChangeLog
index 393ca21..a885aff 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Tue Jan 26 12:20:56 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* configure.ac include/tds.h src/tds/Makefile.am src/tds/login.c:
+	* src/tds/sspi.c:
+	- add experimental support for SSPI (not enabled by default)
+
 Tue Jan 26 12:09:58 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* win32/FreeTDS.def win32/winsetup.c:
 	- allow driver registration like ole controls
@@ -2185,4 +2190,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2954 2010/01/26 11:10:51 freddy77 Exp $
+$Id: ChangeLog,v 1.2955 2010/01/26 11:21:10 freddy77 Exp $
diff --git a/configure.ac b/configure.ac
index 451232a..ab53e1f 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.44 2010/01/22 12:42:16 freddy77 Exp $
+dnl $Id: configure.ac,v 1.45 2010/01/26 11:21:10 freddy77 Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.44 $)
+AC_REVISION($Revision: 1.45 $)
 
 AM_INIT_AUTOMAKE([dist-bzip2 no-dist-gzip])
 AC_CONFIG_HEADERS(include/config.h)
@@ -232,6 +232,17 @@ int main()
 	LIBS="$PTHREAD_LIBS $LIBS"
 fi
 
+# check for SSPI
+AC_ARG_ENABLE(sspi,
+  AS_HELP_STRING([--enable-sspi], [enable SSPI support (EXPERIMENTAL)]))
+# disable by default
+enable_sspi=${enable_sspi-no}
+# only if MingW (TODO other compilers)
+test $tds_mingw != yes && enable_sspi=no
+AM_CONDITIONAL(HAVE_SSPI, test "$enable_sspi" = "yes")
+if test "$enable_sspi" = "yes"; then
+	AC_DEFINE(HAVE_SSPI, 1, [Defined if --enable-sspi and SSPI detected])
+fi
 
 # ------------------------------------------------------------
 # Checks for header files.
diff --git a/include/tds.h b/include/tds.h
index 1571531..b5caccb 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.327 2010/01/25 23:05:58 freddy77 Exp $ */
+/* $Id: tds.h,v 1.328 2010/01/26 11:21:10 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1613,8 +1613,12 @@ TDS_INT tds_numeric_change_prec_scale(TDS_NUMERIC * numeric, unsigned char new_p
 /* getmac.c */
 void tds_getmac(TDS_SYS_SOCKET s, unsigned char mac[6]);
 
+#ifndef HAVE_SSPI
 TDSAUTHENTICATION * tds_ntlm_get_auth(TDSSOCKET * tds);
 TDSAUTHENTICATION * tds_gss_get_auth(TDSSOCKET * tds);
+#else
+TDSAUTHENTICATION * tds_sspi_get_auth(TDSSOCKET * tds);
+#endif
 
 /* bulk.c */
 typedef struct tds_bcpinfo
diff --git a/src/tds/Makefile.am b/src/tds/Makefile.am
index 60a194c..df8f185 100644
--- a/src/tds/Makefile.am
+++ b/src/tds/Makefile.am
@@ -1,20 +1,29 @@
-# $Id: Makefile.am,v 1.70 2010/01/22 09:37:58 freddy77 Exp $
+# $Id: Makefile.am,v 1.71 2010/01/26 11:21:10 freddy77 Exp $
 
 SUBDIRS			=	unittests
 AM_CPPFLAGS		=	-I$(top_srcdir)/include
 
 noinst_LTLIBRARIES	=	libtds.la
+if HAVE_SSPI
+AUTH_FILES_DIST	= challenge.c md4.c md5.c des.c gssapi.c hmac_md5.c
+AUTH_FILES	= sspi.c
+else
+AUTH_FILES	= challenge.c md4.c md5.c des.c gssapi.c hmac_md5.c
+AUTH_FILES_DIST	= sspi.c
+endif
 libtds_la_SOURCES=	mem.c token.c util.c login.c read.c \
 	write.c convert.c numeric.c config.c query.c iconv.c \
-	locale.c challenge.c threadsafe.c vstrbuild.c md4.c md5.c \
-	des.c tdsstring.c getmac.c data.c net.c \
+	locale.c threadsafe.c vstrbuild.c \
+	tdsstring.c getmac.c data.c net.c \
 	tds_checks.c tds_checks.h enum_cap.h log.c \
-	gssapi.c hmac_md5.c bulk.c
+	bulk.c \
+	$(AUTH_FILES)
 libtds_la_LDFLAGS=
 libtds_la_LIBADD=
 
 noinst_HEADERS		= tds_willconvert.h encodings.h num_limits.h types.h
-EXTRA_DIST		= tds_willconvert.h encodings.h num_limits.h types.h TDS.vcproj
+EXTRA_DIST		= tds_willconvert.h encodings.h num_limits.h types.h \
+	TDS.vcproj $(AUTH_FILES_DIST)
 
 if HAVE_DOXYGEN
 doxyfile: $(srcdir)/tds.dox
diff --git a/src/tds/login.c b/src/tds/login.c
index 6c33546..ccca13c 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -1,6 +1,6 @@
 /* FreeTDS - Library of routines accessing Sybase and Microsoft databases
  * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005  Brian Bruns
- * Copyright (C) 2005, 2006, 2007, 2008  Ziglio Frediano
+ * Copyright (C) 2005-2010  Ziglio Frediano
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.193 2010/01/11 18:14:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.194 2010/01/26 11:21:10 freddy77 Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -743,6 +743,14 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	packet_size = current_pos + (host_name_len + app_name_len + server_name_len + library_len + language_len + database_len) * 2;
 
 	/* check ntlm */
+#ifdef HAVE_SSPI
+	if (strchr(user_name, '\\') != NULL || user_name_len == 0) {
+		tds->authentication = tds_sspi_get_auth(tds);
+		if (!tds->authentication)
+			return TDS_FAIL;
+		auth_len = tds->authentication->packet_len;
+		packet_size += auth_len;
+#else
 	if (strchr(user_name, '\\') != NULL) {
 		tds->authentication = tds_ntlm_get_auth(tds);
 		if (!tds->authentication)
@@ -750,15 +758,16 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		auth_len = tds->authentication->packet_len;
 		packet_size += auth_len;
 	} else if (user_name_len == 0) {
-#ifdef ENABLE_KRB5
+# ifdef ENABLE_KRB5
 		/* try kerberos */
 		tds->authentication = tds_gss_get_auth(tds);
 		if (!tds->authentication)
 			return TDS_FAIL;
 		auth_len = tds->authentication->packet_len;
 		packet_size += auth_len;
-#else
+# else
 		return TDS_FAIL;
+# endif
 #endif
 	} else
 		packet_size += (user_name_len + password_len) * 2;
diff --git a/src/tds/sspi.c b/src/tds/sspi.c
new file mode 100644
index 0000000..86c3735
--- /dev/null
+++ b/src/tds/sspi.c
@@ -0,0 +1,240 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2010  Frediano Ziglio
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+
+#if HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#if HAVE_STDLIB_H
+#include <stdlib.h>
+#endif /* HAVE_STDLIB_H */
+
+#if HAVE_STRING_H
+#include <string.h>
+#endif /* HAVE_STRING_H */
+
+#if HAVE_SSPI
+
+#include <windows.h>
+#include <security.h>
+#include <sspi.h>
+#include <rpc.h>
+
+#include "tds.h"
+#include "tdsstring.h"
+#include "replacements.h"
+
+#ifdef DMALLOC
+#include <dmalloc.h>
+#endif
+
+TDS_RCSID(var, "$Id: sspi.c,v 1.1 2010/01/26 11:21:10 freddy77 Exp $");
+
+/**
+ * \ingroup libtds
+ * \defgroup auth Authentication
+ * Functions for handling authentication.
+ */
+
+/**
+ * \addtogroup auth
+ * @{
+ */
+
+typedef struct tds_sspi_auth
+{
+	TDSAUTHENTICATION tds_auth;
+	CredHandle cred;
+	CtxtHandle cred_ctx;
+} TDSSSPIAUTH;
+
+static HMODULE secdll = NULL;
+static PSecurityFunctionTableA sec_fn = NULL;
+
+static int
+tds_init_secdll(void)
+{
+	/* FIXME therad safe !!! */
+	if (!secdll) {
+		OSVERSIONINFO osver;
+
+		memset(&osver, 0, sizeof(osver));
+		osver.dwOSVersionInfoSize = sizeof(osver);
+		if (!GetVersionEx(&osver))
+			return 0;
+		if (osver.dwPlatformId == VER_PLATFORM_WIN32_NT && osver.dwMajorVersion <= 4)
+			secdll = LoadLibrary("security.dll");
+		else
+			secdll = LoadLibrary("secur32.dll");
+		if (!secdll)
+			return 0;
+	}
+	if (!sec_fn) {
+		INIT_SECURITY_INTERFACE_A pInitSecurityInterface;
+
+		pInitSecurityInterface = (INIT_SECURITY_INTERFACE_A) GetProcAddress(secdll, "InitSecurityInterfaceA");
+		if (!pInitSecurityInterface)
+			return 0;
+
+		sec_fn = pInitSecurityInterface();
+		if (!sec_fn)
+			return 0;
+	}
+	return 1;
+}
+
+static int
+tds_sspi_free(TDSSOCKET * tds, struct tds_authentication * tds_auth)
+{
+	TDSSSPIAUTH *auth = (TDSSSPIAUTH *) tds_auth;
+
+	sec_fn->DeleteSecurityContext(&auth->cred_ctx);
+	sec_fn->FreeCredentialsHandle(&auth->cred);
+	free(auth->tds_auth.packet);
+	free(auth);
+	return TDS_SUCCEED;
+}
+
+enum { NTLMBUF_LEN = 4096 };
+
+static int
+tds_sspi_handle_next(TDSSOCKET * tds, struct tds_authentication * tds_auth, size_t len)
+{
+	SecBuffer in_buf, out_buf;
+	SecBufferDesc in_desc, out_desc;
+	SECURITY_STATUS status;
+	ULONG attrs;
+	TimeStamp ts;
+	TDS_UCHAR *auth_buf;
+
+	TDSSSPIAUTH *auth = (TDSSSPIAUTH *) tds_auth;
+
+	if (len < 32 || len > NTLMBUF_LEN)
+		return TDS_FAIL;
+
+	auth_buf = (TDS_UCHAR *) malloc(len);
+	if (!auth_buf)
+		return TDS_FAIL;
+	tds_get_n(tds, auth_buf, len);
+
+	in_desc.ulVersion  = out_desc.ulVersion  = SECBUFFER_VERSION;
+	in_desc.cBuffers   = out_desc.cBuffers   = 1;
+	in_desc.pBuffers   = &in_buf;
+	out_desc.pBuffers   = &out_buf;
+
+	in_buf.BufferType = SECBUFFER_TOKEN;
+	in_buf.pvBuffer   = auth_buf;
+	in_buf.cbBuffer   = len;
+
+	out_buf.BufferType = SECBUFFER_TOKEN;
+	out_buf.pvBuffer   = auth->tds_auth.packet;
+	out_buf.cbBuffer   = NTLMBUF_LEN;
+
+	status = sec_fn->InitializeSecurityContextA(&auth->cred, &auth->cred_ctx,
+		// (char *) host,
+		NULL,
+		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
+		0, SECURITY_NETWORK_DREP, &in_desc,
+		0, &auth->cred_ctx, &out_desc,
+		&attrs, &ts);
+
+	free(auth_buf);
+
+	if (status != SEC_E_OK)
+		return TDS_FAIL;
+
+	tds_put_n(tds, auth->tds_auth.packet, out_buf.cbBuffer);
+
+	return tds_flush_packet(tds);
+}
+
+/**
+ * Build a SSPI packet to send to server
+ * @param tds     A pointer to the TDSSOCKET structure managing a client/server operation.
+ */
+TDSAUTHENTICATION *
+tds_sspi_get_auth(TDSSOCKET * tds)
+{
+	SecBuffer buf;
+	SecBufferDesc desc;
+	SECURITY_STATUS status;
+	ULONG attrs;
+	TimeStamp ts;
+
+	TDSSSPIAUTH *auth;
+
+	if (!tds_init_secdll())
+		return NULL;
+
+	auth = (TDSSSPIAUTH *) calloc(1, sizeof(TDSSSPIAUTH));
+	if (!auth || !tds->connection)
+		return NULL;
+
+	auth->tds_auth.free = tds_sspi_free;
+	auth->tds_auth.handle_next = tds_sspi_handle_next;
+
+	/* TODO parse user/pass and use them if available */
+	/* TODO use SPNEGO to use Kerberos if possible */
+	if (sec_fn->AcquireCredentialsHandleA(NULL, (char *)"NTLM", SECPKG_CRED_OUTBOUND,
+		NULL, NULL, // ntlm->p_identity,
+		NULL, NULL, &auth->cred, &ts) != SEC_E_OK) {
+		free(auth);
+		return NULL;
+	}
+
+	auth->tds_auth.packet = (TDS_UCHAR *) malloc(NTLMBUF_LEN);
+	if (!auth->tds_auth.packet) {
+		sec_fn->FreeCredentialsHandle(&auth->cred);
+		free(auth);
+		return NULL;
+	}
+	desc.ulVersion = SECBUFFER_VERSION;
+	desc.cBuffers  = 1;
+	desc.pBuffers  = &buf;
+
+	buf.cbBuffer   = NTLMBUF_LEN;
+	buf.BufferType = SECBUFFER_TOKEN;
+	buf.pvBuffer   = auth->tds_auth.packet;
+
+	status = sec_fn->InitializeSecurityContextA(&auth->cred, NULL,
+		//(char *) host,
+		"",
+		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
+		0, SECURITY_NETWORK_DREP,
+		NULL, 0,
+		&auth->cred_ctx, &desc,
+		&attrs, &ts);
+
+	if (status == SEC_I_COMPLETE_AND_CONTINUE || status == SEC_I_CONTINUE_NEEDED) {
+		sec_fn->CompleteAuthToken(&auth->cred_ctx, &desc);
+	} else if(status != SEC_E_OK) {
+		free(auth->tds_auth.packet);
+		sec_fn->FreeCredentialsHandle(&auth->cred);
+		free(auth);
+		return NULL;
+	}
+
+	auth->tds_auth.packet_len = buf.cbBuffer;
+	return &auth->tds_auth;
+}
+
+#endif
+
+/** @} */
+

